//+------------------------------------------------------------------+
//|                                            Exp_3XMA_Ishimoku.mq5 |
//|                               Copyright  2012, Nikolay Kositsin | 
//|                                Khabarovsk, farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum MODE_PRICE // 
  {
   OPEN = 0,     //  
   LOW,          // 
   HIGH,         // 
   CLOSE         //  
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|            |
//+----------------------------------------------+
input double MM=-0.1;             //      ,   -  
input int    StopLoss_=1000;      //  
input int    TakeProfit_=2000;    //  
input int    Deviation_=10;       //.    
input bool   BuyPosOpen=true;     //    
input bool   SellPosOpen=true;    //    
input bool   BuyPosClose=true;     //    
input bool   SellPosClose=true;    //    
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_H4; // 

input uint Up_period1=3; //1 ,      
input uint Dn_period1=3; //1 ,      
//----
input uint Up_period2=6; //2 ,      
input uint Dn_period2=6; //2 ,      
//----
input uint Up_period3=9; //3 ,      
input uint Dn_period3=9; //3 ,      
//---- 
input MODE_PRICE Up_mode1=HIGH;  //1     
input MODE_PRICE Dn_mode1=LOW;   //1     
//---- 
input MODE_PRICE Up_mode2=HIGH;  //2     
input MODE_PRICE Dn_mode2=LOW;   //2     
//---- 
input MODE_PRICE Up_mode3=HIGH;  //3     
input MODE_PRICE Dn_mode3=LOW;   //3     
//---- 
input Smooth_Method XMA1_Method=MODE_SMA; //1  
input Smooth_Method XMA2_Method=MODE_SMA; //2  
input Smooth_Method XMA3_Method=MODE_SMA; //3  
//----
input int XLength1=8; //1   
input int XLength2=25; //2  
input int XLength3=80; //3  
//----                  
input int XPhase=15; // ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//---- 
input uint SignalBar=1; //     
//+----------------------------------------------+

int TimeShiftSec;
//----      
int InpInd_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----    3XMA_Ishimoku
   InpInd_Handle=iCustom(Symbol(),InpInd_Timeframe,"3XMA_Ishimoku",Up_period1,Dn_period1,
                         Up_period2,Dn_period2,Up_period3,Dn_period3,Up_mode1,Dn_mode1,Up_mode2,Dn_mode2,
                         Up_mode3,Dn_mode3,XMA1_Method,XMA2_Method,XMA3_Method,XLength1,XLength2,XLength3,XPhase,0,0,0);
   if(InpInd_Handle==INVALID_HANDLE) Print("      3XMA_Ishimoku");

//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----     
   CXMA XMA;
//----     
   int min_rates_1=int(MathMax(Up_period1,Dn_period1));
   min_rates_1+=XMA.GetStartBars(XMA1_Method,XLength1,XPhase);
   int min_rates_2=int(MathMax(Up_period2,Dn_period2));
   min_rates_1+=XMA.GetStartBars(XMA2_Method,XLength2,XPhase);
   int min_rates_3=int(MathMax(Up_period3,Dn_period3));
   min_rates_3+=XMA.GetStartBars(XMA3_Method,XLength3,XPhase);
   min_rates_total=MathMax(min_rates_1,MathMax(min_rates_2,min_rates_3));
   min_rates_total+=int(2+SignalBar);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   GlobalVariableDel_(Symbol());
//----
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(InpInd_Handle)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);

//----   
   double DnValue[2],UpValue[2],XmaValue[2];
//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;

//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) //     
     {
      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;

      //----      
      if(CopyBuffer(InpInd_Handle,0,SignalBar,2,XmaValue)<=0) {Recount=true; return;}
      if(CopyBuffer(InpInd_Handle,1,SignalBar,2,UpValue)<=0) {Recount=true; return;}
      if(CopyBuffer(InpInd_Handle,2,SignalBar,2,DnValue)<=0) {Recount=true; return;}

      //----    
      if(XmaValue[1]>MathMax(UpValue[1],DnValue[1]))
        {
         if(BuyPosOpen) if(XmaValue[0]<=MathMax(UpValue[0],DnValue[0])) BUY_Open=true;
         if(SellPosClose) SELL_Close=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }

      //----    
      if(XmaValue[1]<MathMin(UpValue[1],DnValue[1]))
        {
         if(SellPosOpen) if(XmaValue[0]>=MathMin(UpValue[0],DnValue[0])) SELL_Open=true;
         if(BuyPosClose) BUY_Close=true;
         DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }
     }

//+----------------------------------------------+
//|                              |
//+----------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);
//----
  }
//+------------------------------------------------------------------+
